package de.hdm_stuttgart.mi.sd1.binomial;

public class Binomial {

  public static long binomial(int n, int k) {
    
    // Trying to avoid arithmetic overflow by making use of:
    //             n        n
    //           (   ) =  (   )
    //             k       n-k
    //
    if (n / 2 < k) {
      k = n - k;
    }
    
    // Numerator product n (n - 1) ... (n - k + 1)
    long numerator = 1;
    for (int i = n - k + 1; i <= n; i++) {
      numerator *= i;
    }
    return numerator / factorial(k);
  }
  
  public static long factorial(int n) {
    long ret = 1;
    
    for (int i = 2; i <= n; i++) {
      ret *= i;
    }
    return ret;
  }
}
