package de.hdm_stuttgart.mi.persistence.test;

import java.sql.SQLException;

import org.junit.Assert;
import org.junit.Test;

import de.hdm_stuttgart.mi.persistence.PersistenceHandler;

/**
 *
 */
public class DataInsertTest {

   final ViewMockup viewMockup = new ViewMockup();

   final PersistenceHandler ph = new PersistenceHandler(viewMockup);

   /**
    */
   @Test ()
   public void addDatasets() {
      try {
         InitDatabase.initDatabase();
      } catch (SQLException e) {
         Assert.fail("Unable to initialize database:" + e.getLocalizedMessage());
         return;
      }
      ph.connect("admin", "Hello!");
      Assert.assertTrue(ph.insert("Anton", "a@mail.com", "anton", "secret"));

      // Failure expected due to primary key constraint violation
      Assert.assertFalse(ph.insert("Anton", "a@mail.com", "anton", "secret"));
      Assert.assertNotNull(viewMockup.error);
      Assert.assertEquals(
            "E-mail already in database",
            viewMockup.error);

      try {
         InitDatabase.initDatabase();
      } catch (SQLException e) {
         System.err.println("Unable to clean database");
      }
      // TODO: Reconnect??
      Assert.assertTrue(ph.insert("Anton", "a@mail.com", "anton", "secret"));

   }

   
}
